$regfile = "m32def.dat"                                     'procesor ATmega32
$crystal = 12000000
$lib "DATETIME.LBX"
Config Scl = Portd.5
Config Sda = Portd.4
Config Date = Dmy , Separator = -

Config Lcd = 20 * 2
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portd.3 , Rs = Portd.2
Cursor Off

Config Timer0 = Timer , Prescale = 64
On Timer0 Wyswietl
Timer0 = 0
Enable Interrupts
Enable Timer0

Deflcdchar 1 , 32 , 32 , 14 , 1 , 15 , 17 , 15 , 2          ' znak 
Deflcdchar 2 , 2 , 4 , 22 , 25 , 17 , 17 , 17 , 32          ' znak 
Deflcdchar 3 , 2 , 4 , 14 , 16 , 14 , 1 , 30 , 32           ' znak 
Deflcdchar 4 , 2 , 4 , 15 , 16 , 16 , 16 , 15 , 32          ' znak 
Deflcdchar 5 , 12 , 4 , 6 , 4 , 12 , 4 , 14 , 32            ' znak 


Config Porta = Output                                       'segmenty wywietlacza
Porta = 0

Config Portb.4 = Input                                      'przycisk S1
Set Portb.4

Config Portb.5 = Input                                      'przycisk S2
Set Portb.5

Config Portb.6 = Input                                      'przycisk S3
Set Portb.6

Config Portb.7 = Input                                      'przycisk S4
Set Portb.7

Config Portc = Output                                       'cyfry 1. - 8.
Portc = 0

Config Portd.0 = Output                                     'linia RXD
Set Portd.0

Config Portd.1 = Output                                     'linia TXD
Set Portd.1

Config Portd.6 = Output                                     'cyfra 10.
Reset Portd.6

Config Portd.7 = Output                                     'cyfra 9.
Reset Portd.7

S1 Alias Pinb.4
S2 Alias Pinb.5
S3 Alias Pinb.6
S4 Alias Pinb.7

Dim Sekundy As Byte , Minuty As Byte , Godziny As Byte , Dni As Byte , Miesiace As Byte , Lata As Byte       'odczytane z RTC
Dim Kategoria As Byte , Menu As Byte , Licznik As Byte , Latatmp As Word , Latakontmp As Word , Dnimax As Byte       'pomocnicze
Dim Kalibr As Byte , Kalibrtmp As Byte , Kalibrznak As Byte , Znak As String * 1       'do kalibracji
Dim Sekkon As Byte , Minkon As Byte , Godzkon As Byte , Dnikon As Byte , Mieskon As Byte , Latakon As Byte       'ustawianie zakonczenia
Dim Kdatastring As String * 8 , Kczasstring As String * 8 , Sekundykon As Long , Sekundyrtc As Long , Roznica As Long
Dim Sekjedn As Byte , Sekdzies As Byte , Minjedn As Byte , Mindzies As Byte , Godzjedn As Byte , Godzdzies As Byte , Dnijedn As Byte , Dnidzies As Byte , Dniset As Byte , Dnitys As Byte       'zawartoci tych zmiennych bd wywietlane
Dim Cyfra As Byte , Rdatastring As String * 8 , Rczasstring As String * 8
Dim Sekpoma As Long , Sekpomb As Long                       'zmienne pomocnicze do prawidowego przekonwertowania SYSSEC - czasem sypie bd
Dim Wygasz As Byte                                          'zm okrelajca czy maj by wygaszane zbdne zera: 0 - zostaw, 1 - wyga

Readeeprom Sekkon , 3
Readeeprom Minkon , 5
Readeeprom Godzkon , 7
Readeeprom Dnikon , 9
Readeeprom Mieskon , 11
Readeeprom Latakon , 20
Readeeprom Wygasz , 22

If Sekkon >= 60 Then
Sekkon = 0
Writeeeprom Sekkon , 3
End If

If Minkon >= 60 Then
Minkon = 0
Writeeeprom Minkon , 5
End If

If Godzkon >= 24 Then
Godzkon = 0
Writeeeprom Godzkon , 7
End If

If Dnikon >= 32 Then
Dnikon = 1
Writeeeprom Dnikon , 9
End If

If Mieskon >= 13 Then
Mieskon = 1
Writeeeprom Mieskon , 11
End If

If Latakon >= 60 Then
Latakon = 12
Writeeeprom Latakon , 20
End If

If Wygasz >= 2 Then
Wygasz = 0
Writeeeprom Wygasz , 22
End If

Menu = 0
Kategoria = 0

Do

If S3 = 0 And Menu = 0 Then
Incr Kategoria
If Kategoria >= 3 Then
Kategoria = 0
End If
End If

If S4 = 0 And Menu = 0 Then
Decr Kategoria
If Kategoria >= 3 Then
Kategoria = 2
End If
End If

If S1 = 0 Or S2 = 0 Or S3 = 0 Or S4 = 0 Then
Licznik = 0
End If

If Menu <> 0 Or Kategoria <> 0 Then
Incr Licznik
Porta = 0
Portc = 0
Reset Portd.6
Reset Portd.7
Disable Timer0
Else
Licznik = 0
Enable Timer0
End If

If Licznik >= 41 Then
Menu = 0
Kategoria = 0
End If

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

If Menu = 0 And Kategoria = 0 Then
I2cstart
I2cwbyte &HD0
I2cwbyte 0
I2cstart
I2cwbyte &HD1
I2crbyte Sekundy , Nack
I2cstop

I2cstart
I2cwbyte &HD0
I2cwbyte 1
I2cstart
I2cwbyte &HD1
I2crbyte Minuty , Nack
I2cstop

I2cstart
I2cwbyte &HD0
I2cwbyte 2
I2cstart
I2cwbyte &HD1
I2crbyte Godziny , Nack
I2cstop

I2cstart
I2cwbyte &HD0
I2cwbyte 4
I2cstart
I2cwbyte &HD1
I2crbyte Dni , Nack
I2cstop

I2cstart
I2cwbyte &HD0
I2cwbyte 5
I2cstart
I2cwbyte &HD1
I2crbyte Miesiace , Nack
I2cstop

I2cstart
I2cwbyte &HD0
I2cwbyte 6
I2cstart
I2cwbyte &HD1
I2crbyte Lata , Nack
I2cstop

'------------------------

Sekundy = Sekundy And &B01111111
Minuty = Minuty And &B01111111
Godziny = Godziny And &B00111111
Dni = Dni And &B00111111
Miesiace = Miesiace And &B00011111

Sekundy = Makedec(sekundy)
Minuty = Makedec(minuty)
Godziny = Makedec(godziny)
Dni = Makedec(dni)
Miesiace = Makedec(miesiace)
Lata = Makedec(lata)

'------------------------

If Dnikon >= 10 Then
Kdatastring = Str(dnikon)
Else
Kdatastring = "0" + Str(dnikon)
End If

Kdatastring = Kdatastring + "-"

If Mieskon >= 10 Then
Kdatastring = Kdatastring + Str(mieskon)
Else
Kdatastring = Kdatastring + "0" + Str(mieskon)
End If

Kdatastring = Kdatastring + "-"
Kdatastring = Kdatastring + Str(latakon)

If Godzkon >= 10 Then
Kczasstring = Str(godzkon)
Else
Kczasstring = "0" + Str(godzkon)
End If

Kczasstring = Kczasstring + ":"

If Minkon >= 10 Then
Kczasstring = Kczasstring + Str(minkon)
Else
Kczasstring = Kczasstring + "0" + Str(minkon)
End If

Kczasstring = Kczasstring + ":"

If Sekkon >= 10 Then
Kczasstring = Kczasstring + Str(sekkon)
Else
Kczasstring = Kczasstring + "0" + Str(sekkon)
End If


Sekpoma = Syssec(kczasstring , Kdatastring)
Sekpomb = Syssec(kczasstring , Kdatastring)
While Sekpoma <> Sekpomb
Sekpoma = Syssec(kczasstring , Kdatastring)
Sekpomb = Syssec(kczasstring , Kdatastring)
Wend
Sekundykon = Sekpoma




'------------------------

If Dni >= 10 Then
Rdatastring = Str(dni)
Else
Rdatastring = "0" + Str(dni)
End If

Rdatastring = Rdatastring + "-"

If Miesiace >= 10 Then
Rdatastring = Rdatastring + Str(miesiace)
Else
Rdatastring = Rdatastring + "0" + Str(miesiace)
End If

Rdatastring = Rdatastring + "-"
Rdatastring = Rdatastring + Str(lata)

If Godziny >= 10 Then
Rczasstring = Str(godziny)
Else
Rczasstring = "0" + Str(godziny)
End If

Rczasstring = Rczasstring + ":"

If Minuty >= 10 Then
Rczasstring = Rczasstring + Str(minuty)
Else
Rczasstring = Rczasstring + "0" + Str(minuty)
End If

Rczasstring = Rczasstring + ":"

If Sekundy >= 10 Then
Rczasstring = Rczasstring + Str(sekundy)
Else
Rczasstring = Rczasstring + "0" + Str(sekundy)
End If

Sekpoma = Syssec(rczasstring , Rdatastring)
Sekpomb = Syssec(rczasstring , Rdatastring)
While Sekpoma <> Sekpomb
Sekpoma = Syssec(rczasstring , Rdatastring)
Sekpomb = Syssec(rczasstring , Rdatastring)
Wend
Sekundyrtc = Sekpoma

Roznica = Sekundykon - Sekundyrtc


If Roznica >= 0 And Roznica < 864000000 Then

Latatmp = Lata + 2000
Latakontmp = Latakon + 2000
Cls
Lcd Godziny ; ":" ; Minuty ; ":" ; Sekundy ; " "

If Godziny <= 9 Then
Lcd " "
End If

If Minuty <= 9 Then
Lcd " "
End If

If Sekundy <= 9 Then
Lcd " "
End If

Lcd Dni ; "-" ; Miesiace ; "-" ; Latatmp
'Lcd Rdatastring ; " " ; Rczasstring
'Lcd Sekundyrtc
Lowerline
'Lcd Sekundykon
Lcd Godzkon ; ":" ; Minkon ; ":" ; Sekkon ; " "

If Godzkon <= 9 Then
Lcd " "
End If

If Minkon <= 9 Then
Lcd " "
End If

If Sekkon <= 9 Then
Lcd " "
End If

Lcd Dnikon ; "-" ; Mieskon ; "-" ; Latakontmp
'Lcd Kdatastring ; " " ; Kczasstring
'Lcd Dnitys ; Dniset ; Dnidzies ; Dnijedn ; " " ; Godzdzies ; Godzjedn ; " " ; Mindzies ; Minjedn ; " " ; Sekdzies ; Sekjedn


End If

'---------------------------------------------------

If Roznica < 0 Or Roznica >= 864000000 Then

Dnitys = 10
Dniset = 10
Dnidzies = 10
Dnijedn = 10
Godzdzies = 10
Godzjedn = 10
Mindzies = 10
Minjedn = 10
Sekdzies = 10
Sekjedn = 10

Cls
Lcd Godziny ; ":" ; Minuty ; ":" ; Sekundy ; "  " ; Dni ; "-" ; Miesiace ; "-" ; Latatmp
'Lcd Rdatastring ; " " ; Rczasstring
'Lcd Sekundyrtc
Lowerline
Lcd "Data nieprawid" ; Chr(5) ; "owa!"
End If


'------------------------


End If

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

If Kategoria = 1 Then

If S1 = 0 Then
Incr Menu
If Menu >= 8 Then
Menu = 0
End If
End If

If S2 = 0 Then
Decr Menu
If Menu >= 8 Then
Menu = 7
End If
End If

'---------------------------------------------------

If Menu = 0 Then
Cls
Lcd "Ustawianie RTC"
Lowerline
Lcd "Dalej: S1 lub S2"
End If

'---------------------------------------------------

If Menu = 1 Then
Latatmp = 0
Latatmp = Lata + 2000
Cls
Lcd "1)Ust. roku S3+ S4-"
Lowerline
Lcd "Rok:  " ; Latatmp


If S3 = 0 Then
Incr Latatmp
If Latatmp >= 2061 Then
Latatmp = 2012
End If
End If

If S4 = 0 Then
Decr Latatmp
If Latatmp <= 2011 Then
Latatmp = 2060
End If
End If

Lata = Latatmp - 2000
Lata = Makebcd(lata)
I2cstart
I2cwbyte &HD0
I2cwbyte 6
I2cwbyte Lata
I2cstop
Lata = Makedec(lata)
End If
'---------------------------------------------------

If Menu = 2 Then
Cls
Lcd "2)Ust. mies. S3+ S4-"
Lowerline
Lcd "Miesi" ; Chr(1) ; "c:  " ; Miesiace

If S3 = 0 Then
Incr Miesiace
If Miesiace >= 13 Then
Miesiace = 1
End If
End If

If S4 = 0 Then
Decr Miesiace
If Miesiace >= 13 Then
Miesiace = 12
End If
End If

Miesiace = Makebcd(miesiace)
I2cstart
I2cwbyte &HD0
I2cwbyte 5
I2cwbyte Miesiace
I2cstop
Miesiace = Makedec(miesiace)
End If

'---------------------------------------------------

If Menu = 3 Then
Latatmp = 0
Cls
Lcd "3)Ust. dni S3+ S4-"
Lowerline
Lcd "Dzie" ; Chr(2) ; ":  " ; Dni

If Miesiace = 2 Then
Dnimax = 28
End If
If Miesiace = 4 Or Miesiace = 6 Or Miesiace = 9 Or Miesiace = 11 Then
Dnimax = 30
End If
If Miesiace = 1 Or Miesiace = 3 Or Miesiace = 5 Or Miesiace = 7 Or Miesiace = 8 Or Miesiace = 10 Or Miesiace = 12 Then
Dnimax = 31
End If

Latatmp = Lata Mod 4
If Latatmp = 0 And Miesiace = 2 Then                        'jeeli rok jest przestpny
Dnimax = 29
End If

If S3 = 0 Then
Incr Dni
If Dni > Dnimax Then
Dni = 1
End If
End If

If S4 = 0 Then
Decr Dni
If Dni > Dnimax Then
Dni = Dnimax
End If
End If

Dni = Makebcd(dni)
I2cstart
I2cwbyte &HD0
I2cwbyte 4
I2cwbyte Dni
I2cstop
Dni = Makedec(dni)
End If

'---------------------------------------------------

If Menu = 4 Then
Cls
Lcd "4)Ust. godz. S3+ S4-"
Lowerline
Lcd "Godzina:  " ; Godziny

If S3 = 0 Then
Incr Godziny
If Godziny >= 24 Then
Godziny = 0
End If
End If

If S4 = 0 Then
Decr Godziny
If Godziny >= 24 Then
Godziny = 23
End If
End If

Godziny = Makebcd(godziny)
I2cstart
I2cwbyte &HD0
I2cwbyte 2
I2cwbyte Godziny
I2cstop
Godziny = Makedec(godziny)
End If


'---------------------------------------------------

If Menu = 5 Then
Cls
Lcd "5)Ust. minut S3+ S4-"
Lowerline
Lcd "Minuta:  " ; Minuty

If S3 = 0 Then
Incr Minuty
If Minuty >= 60 Then
Minuty = 0
End If
End If

If S4 = 0 Then
Decr Minuty
If Minuty >= 60 Then
Minuty = 59
End If
End If

Minuty = Makebcd(minuty)
I2cstart
I2cwbyte &HD0
I2cwbyte 1
I2cwbyte Minuty
I2cstop
Minuty = Makedec(minuty)
End If

'---------------------------------------------------

If Menu = 6 Then
Cls
Lcd "6)Zerowanie sekund"
Lowerline
Lcd "i start RTC: S3 lub S4"
If S3 = 0 Or S4 = 0 Then
I2cstart
I2cwbyte &HD0
I2cwbyte 0
I2cwbyte 0
I2cstop
End If
End If

'---------------------------------------------------

If Menu = 7 Then

I2cstart
I2cwbyte &HD0
I2cwbyte 7
I2cstart
I2cwbyte &HD1
I2crbyte Kalibr , Nack
I2cstop

Kalibr = Kalibr And &B00111111
Kalibrznak = Kalibr And &B00100000
Kalibrtmp = Kalibr And &B00011111

If Kalibrznak = 0 Then
Znak = "-"
End If

If Kalibrznak = &B00100000 Then
Znak = "+"
End If

If Kalibr = 0 Then
Znak = " "
End If

Cls
Lcd "7)Kalibr: S3 i S4+/-"
Lowerline
Lcd "Warto" ; Chr(3) ; Chr(4) ; ":  " ; Znak ; Kalibrtmp

If S3 = 0 Then
Incr Kalibrtmp
If Kalibrtmp >= 32 Then
Kalibrtmp = 0
End If
End If

If S4 = 0 And Kalibrznak = 0 Then
Kalibrznak = &B00100000
Waitms 500
End If

If S4 = 0 And Kalibrznak = &B00100000 Then
Kalibrznak = 0
Waitms 500
End If


Kalibr = Kalibrtmp Or Kalibrznak

I2cstart
I2cwbyte &HD0
I2cwbyte 7
I2cwbyte Kalibr
I2cstop

End If

End If

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

If Kategoria = 2 Then


If S1 = 0 Then
Incr Menu
If Menu >= 8 Then
Menu = 0
End If
End If

If S2 = 0 Then
Decr Menu
If Menu >= 8 Then
Menu = 7
End If
End If

'---------------------------------------------------

If Menu = 0 Then
Cls
Lcd "Ustawianie ko" ; Chr(2) ; "ca"
Lowerline
Lcd "Dalej: S1 lub S2"

End If

'---------------------------------------------------

If Menu = 1 Then
Latakontmp = Latakon
Latakontmp = Latakontmp + 2000
Cls
Lcd "1)Kon. rok. S3+ S4-"
Lowerline
Lcd "Rok: " ; "  " ; Latakontmp

If S3 = 0 Then
Incr Latakontmp
If Latakontmp >= 2061 Then
Latakontmp = 2012
End If
End If

If S4 = 0 Then
Decr Latakontmp
If Latakontmp <= 2011 Then
Latakontmp = 2060
End If
End If

Latakontmp = Latakontmp - 2000
Latakon = Latakontmp

End If

'---------------------------------------------------

If Menu = 2 Then
Cls
Lcd "2)Kon. mies. S3+ S4-"
Lowerline
Lcd "Miesi" ; Chr(1) ; "c:  " ; Mieskon

If S3 = 0 Then
Incr Mieskon
If Mieskon >= 13 Then
Mieskon = 1
End If
End If

If S4 = 0 Then
Decr Mieskon
If Mieskon >= 13 Then
Mieskon = 12
End If
End If

End If

'---------------------------------------------------

If Menu = 3 Then
Latatmp = 0
Cls
Lcd "3)Kon. dzien S3+ S4-"
Lowerline
Lcd "Dzie" ; Chr(2) ; ":  " ; Dnikon

If Mieskon = 2 Then
Dnimax = 28
End If
If Mieskon = 4 Or Mieskon = 6 Or Mieskon = 9 Or Mieskon = 11 Then
Dnimax = 30
End If
If Mieskon = 1 Or Mieskon = 3 Or Mieskon = 5 Or Mieskon = 7 Or Mieskon = 8 Or Mieskon = 10 Or Mieskon = 12 Then
Dnimax = 31
End If

Latatmp = Latakon Mod 4
If Latatmp = 0 And Mieskon = 2 Then                         'jeeli rok jest przestpny
Dnimax = 29
End If

If S3 = 0 Then
Incr Dnikon
If Dnikon > Dnimax Then
Dnikon = 1
End If
End If

If S4 = 0 Then
Decr Dnikon
If Dnikon > Dnimax Then
Dnikon = Dnimax
End If
End If


End If

'---------------------------------------------------

If Menu = 4 Then
Cls
Lcd "4)Kon. godz. S3+ S4-"
Lowerline
Lcd "Godzina: " ; "  " ; Godzkon

If S3 = 0 Then
Incr Godzkon
If Godzkon >= 24 Then
Godzkon = 0
End If
End If

If S4 = 0 Then
Decr Godzkon
If Godzkon >= 24 Then
Godzkon = 23
End If
End If

End If

'---------------------------------------------------

If Menu = 5 Then
Cls
Lcd "5)Kon. min. S3+ S4-"
Lowerline
Lcd "Minuta: " ; "  " ; Minkon

If S3 = 0 Then
Incr Minkon
If Minkon >= 60 Then
Minkon = 0
End If
End If

If S4 = 0 Then
Decr Minkon
If Minkon >= 60 Then
Minkon = 59
End If
End If

End If

'---------------------------------------------------

If Menu = 6 Then
Cls
Lcd "6)Kon. sek. S3+ S4-"
Lowerline
Lcd "Sekunda: " ; "  " ; Sekkon

If S3 = 0 Then
Incr Sekkon
If Sekkon >= 60 Then
Sekkon = 0
End If
End If

If S4 = 0 Then
Decr Sekkon
If Sekkon >= 60 Then
Sekkon = 59
End If
End If

End If

'---------------------------------------------------

If Menu = 7 Then

If Wygasz = 0 Then
Cls
Lcd "7)Wygaszanie zb. zer"
Lowerline
Lcd "Wygaszanie wy" ; Chr(5) ; Chr(1) ; "czone"
End If

If Wygasz = 1 Then
Cls
Lcd "7)Wygaszanie zb. zer"
Lowerline
Lcd "Wygaszanie za" ; Chr(5) ; Chr(1) ; "czone"
End If

If S3 = 0 Then
Incr Wygasz
If Wygasz >= 2 Then
Wygasz = 0
End If
End If

If S4 = 0 Then
Decr Wygasz
If Wygasz >= 2 Then
Wygasz = 1
End If
End If

If Wygasz >= 2 Then
Wygasz = 0
End If

End If

'---------------------------------------------------

If Licznik >= 40 Then
Cls
Lcd "Zapis do EEPROM"
Waitms 500

Writeeeprom Sekkon , 3
Writeeeprom Minkon , 5
Writeeeprom Godzkon , 7
Writeeeprom Dnikon , 9
Writeeeprom Mieskon , 11
Writeeeprom Latakon , 20
Writeeeprom Wygasz , 22
Menu = 0
Kategoria = 0
Licznik = 0
End If

End If

Waitms 200
Loop
End

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

Wyswietl:

Timer0 = 0

Portc = 0
Reset Portd.6
Reset Portd.7

Incr Cyfra
If Cyfra >= 11 Then
Cyfra = 1
End If

Roznica = Sekundykon - Sekundyrtc

If Roznica >= 0 And Roznica < 864000000 Then

Dnitys = 0
While Roznica >= 86400000
Incr Dnitys
Roznica = Roznica - 86400000
Wend
If Wygasz = 1 And Dnitys = 0 Then
Dnitys = 11
End If


Dniset = 0
While Roznica >= 8640000
Incr Dniset
Roznica = Roznica - 8640000
Wend
If Wygasz = 1 And Dniset = 0 And Dnitys = 11 Then
Dniset = 11
End If

Dnidzies = 0
While Roznica >= 864000
Incr Dnidzies
Roznica = Roznica - 864000
Wend
If Wygasz = 1 And Dnidzies = 0 Then
If Dnitys = 11 And Dniset = 11 Then
Dnidzies = 11
End If
End If

Dnijedn = 0
While Roznica >= 86400
Incr Dnijedn
Roznica = Roznica - 86400
Wend

Godzdzies = 0
While Roznica >= 36000
Incr Godzdzies
Roznica = Roznica - 36000
Wend
If Wygasz = 1 And Godzdzies = 0 Then
Godzdzies = 11
End If

Godzjedn = 0
While Roznica >= 3600
Incr Godzjedn
Roznica = Roznica - 3600
Wend

Mindzies = 0
While Roznica >= 600
Incr Mindzies
Roznica = Roznica - 600
Wend
If Wygasz = 1 And Mindzies = 0 Then
Mindzies = 11
End If

Minjedn = 0
While Roznica >= 60
Incr Minjedn
Roznica = Roznica - 60
Wend

Sekjedn = Roznica Mod 10
Roznica = Roznica - Sekjedn
Roznica = Roznica / 10

Sekdzies = Roznica
If Wygasz = 1 And Sekdzies = 0 Then
Sekdzies = 11
End If
End If


If Cyfra = 1 Then
Porta = Lookup(dnitys , Tablica)
Portc = &B10000000
End If

If Cyfra = 2 Then
Porta = Lookup(dniset , Tablica)
Portc = &B01000000
End If

If Cyfra = 3 Then
Porta = Lookup(dnidzies , Tablica)
Portc = &B00100000
End If

If Cyfra = 4 Then
Porta = Lookup(dnijedn , Tablica)
Portc = &B00010000
End If

If Cyfra = 5 Then
Porta = Lookup(godzdzies , Tablica)
Portc = &B00001000
End If

If Cyfra = 6 Then
Porta = Lookup(godzjedn , Tablica)
Portc = &B00000100
End If

If Cyfra = 7 Then
Porta = Lookup(mindzies , Tablica)
Portc = &B00000010
End If

If Cyfra = 8 Then
Porta = Lookup(minjedn , Tablica)
Portc = &B00000001
End If

If Cyfra = 9 Then
Porta = Lookup(sekdzies , Tablica)
Set Portd.7
End If

If Cyfra = 10 Then
Porta = Lookup(sekjedn , Tablica)
Set Portd.6
End If

Return

Tablica:
Data &B11111110 , &B10110000 , &B11101101 , &B11111001 , &B10110011 , &B11011011 , &B11011111 , &B11110000 , &B11111111 , &B11111011 , &B10000001 , &B10000000